#ifndef MLSS_STEGANOHIDE
#define MLSS_STEGANOHIDE

void transfer16Byte1(std::ifstream &input, std::ofstream &output, unsigned char writeByte, encryptClass *encryption);
void transfer16Byte2(std::ifstream &input, std::ofstream &output, unsigned char writeByte, encryptClass *encryption);
void transferByte1(std::ifstream &input, std::ofstream &output, unsigned char writeByte, encryptClass *encryption);
void transferByte2(std::ifstream &input, std::ofstream &output, unsigned char writeByte, encryptClass *encryption);
void transferByte4(std::ifstream &input, std::ofstream &output, unsigned char writeByte, encryptClass *encryption);

int steganoHide(int argc, char **argv);
void showHideHelp();

class hideArgs
{
public:
	hideArgs();
	bool error, scramble;
	std::string hostfile, outputfile, guestfile;
	encryptClass *encryption;
	int bitsperbyte;
	void (*transferByte)(std::ifstream &input, std::ofstream &output, unsigned char writeByte, encryptClass *encryption);
};

hideArgs getHideArgs(int argc, char **argv);

void hideData(std::ifstream &in, std::ofstream &out, std::ifstream &hideIn, std::string guestfile,
			  bool scramble, encryptClass *encryption, int bytesperbyte, int hideSize,
			  void (*transferByte)(std::ifstream &input, std::ofstream &output,
					unsigned char writeByte, encryptClass *encryption),
			  int availibleBytes);

#endif
