#include "treeStringClass.h"

//Note to self: fix security flaw: a very carefully designed input string can lead
//to a buffer overflow

treeString::treeString(const char *creationString, treeNode *children, const int highestDepth)
{
	this->highestDepth = highestDepth;
	this->children = children;
	data = new int*[highestDepth];
	int stringPos = 0;
	for(int i = 0; i < highestDepth; ++i)
	{
		int charactersAtDepth = creationString[stringPos++];
		data[i] = new int[charactersAtDepth + 1];
		data[i][0] = charactersAtDepth;
		for(int j = 1; j <= charactersAtDepth; ++j)
		{
			data[i][j] = creationString[stringPos++];
		}
	}
}

treeString::~treeString()
{
	for(int i = 0; i < highestDepth; ++i)
	{
		delete [] data[i];
	}
	delete [] data;
}

treeNode *treeString::getChildAt(int depth)
{
	--depth;
	if(depth < 0 || depth >= highestDepth)
	{
		return 0;
	}

	if(data[depth][0] == 0)
		return 0;

	treeNode *returnValue = &(children[data[depth][1]]);
	removeCharacterFromDepth(depth);
	return returnValue;
}

void treeString::removeCharacterFromDepth(int depth)
{
	int *tmp = new int[(--(data[depth][0])) + 1];
	tmp[0] = data[depth][0];
	for(int i = 0; i < tmp[0]; ++i)
	{
		tmp[i + 1] = data[depth][i + 2];
	}
	delete [] data[depth];
	data[depth] = tmp;
}

treeNode::treeNode()
{
	reset();
}

void treeNode::reset()
{
	parent = 0;
	child1 = child2 = 0;
	codeLength = code = 0;
	frequency = 0;
	ASCII = 0;
}
